#!/usr/bin/env python

import sys
import os
from glob import glob
import operator

libdirs = [
    os.path.join(os.path.split(__file__)[0], "lib"),
    "/usr/share/micropython/lib"
    ]

# Main program.

if __name__ == "__main__":
    args = sys.argv[1:]
    path = libdirs + sys.path[:]
    path.append("tests")

    # Process all tests.

    try:
        _f = args.index("-f")
        filenames = args[_f+1:]
        args = args[:_f]
    except ValueError:
        filenames = glob(os.path.join("tests", "*.py"))

    filenames.sort()

    # Make some arguments for the test program.

    args.append("-t")
    if "-tb" not in args:
        args.append("-exit")

    results = []

    for filename in filenames:
        print "Processing", filename
        success = 0 == os.system("%s test.py %s %s" % (sys.executable, filename, " ".join(args)))
        print "Test successful?", success and "Yes" or "No"
        results.append((filename, success))

    failed = [result[0] for result in results if not result[1]]
    if failed:
        print
        print "Failed tests:"
        for filename in failed:
            print filename

    print
    print "All successful?"
    print reduce(operator.and_, [x[1] for x in results], 1) and "Yes" or "No"

# vim: tabstop=4 expandtab shiftwidth=4
